summaryrefslogtreecommitdiffstats
path: root/network
diff options
context:
space:
mode:
author P.D. Parnoff <cryptoanarquismo@biofcentral.com>2014-08-06 08:29:10 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2014-08-06 08:29:10 +0700
commit7dddf97e9edeb5322b2f00fa5b806b78940fd02a (patch)
treee98d5cdffa25650e47e2d1fdea50992a77968968 /network
parent477b5200b6dbd626df5c1461ddb03786a42a4897 (diff)
downloadslackbuilds-7dddf97e9edeb5322b2f00fa5b806b78940fd02a.tar.gz
slackbuilds-7dddf97e9edeb5322b2f00fa5b806b78940fd02a.tar.xz
network/slowhttptest: Added (stress testing tool/DoS simulator).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'network')
-rw-r--r--network/slowhttptest/README21
-rw-r--r--network/slowhttptest/slack-desc19
-rw-r--r--network/slowhttptest/slowhttptest.SlackBuild99
-rw-r--r--network/slowhttptest/slowhttptest.info10
4 files changed, 149 insertions, 0 deletions
diff --git a/network/slowhttptest/README b/network/slowhttptest/README
new file mode 100644
index 0000000000..9d1a6bf83a
--- /dev/null
+++ b/network/slowhttptest/README
@@ -0,0 +1,21 @@
+SlowHTTPTest is a highly configurable tool that simulates some Application Layer Denial of Service attacks.
+It works on majority of Linux platforms, OSX and Cygwin - a Unix-like environment and command-line interface
+for Microsoft Windows.
+
+It implements most common low-bandwidth Application Layer DoS attacks, such as slowloris, Slow HTTP POST,
+Slow Read attack (based on TCP persist timer exploit) by draining concurrent connections pool, as well
+as Apache Range Header attack by causing very significant memory and CPU usage on the server.
+
+Slowloris and Slow HTTP POST DoS attacks rely on the fact that the HTTP protocol, by design, requires
+requests to be completely received by the server before they are processed. If an HTTP request is not
+complete, or if the transfer rate is very low, the server keeps its resources busy waiting for the
+rest of the data. If the server keeps too many resources busy, this creates a denial of service.
+This tool is sending partial HTTP requests, trying to get denial of service from target HTTP server.
+
+Slow Read DoS attack aims the same resources as slowloris and slow POST, but instead of prolonging
+the request, it sends legitimate HTTP request and reads the response slowly.
+
+DISCLAIMER: Keep in mind that slowhttptest is of little use as a script kiddie tool. It cannot
+be pointed blindly at arbitrary targets, like e.g. LOIC. Rather, where it excels is in its
+breadth of attack options, high customizability and its in-depth analytics. As such, it will be
+mostly useful for server administrators trying to stress test their systems.
diff --git a/network/slowhttptest/slack-desc b/network/slowhttptest/slack-desc
new file mode 100644
index 0000000000..08859355a9
--- /dev/null
+++ b/network/slowhttptest/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+slowhttptest: slowhttptest (stress testing tool/DoS simulator)
+slowhttptest:
+slowhttptest: slowhttptest is a highly configurable tool that simulates some
+slowhttptest: Application Layer Denial of Service attacks. It implements most
+slowhttptest: common low-bandwidth Application Layer DoS attacks, such as
+slowhttptest: lowloris, Slow HTTP POST, Slow Read attack (based on TCP
+slowhttptest: persist timer exploit) by draining concurrent connections pool,
+slowhttptest: as well as the Apache Range Header attack, leading to resource
+slowhttptest: exhaustion.
+slowhttptest:
+slowhttptest: Project URL: https://code.google.com/p/slowhttptest/
diff --git a/network/slowhttptest/slowhttptest.SlackBuild b/network/slowhttptest/slowhttptest.SlackBuild
new file mode 100644
index 0000000000..731e23fd49
--- /dev/null
+++ b/network/slowhttptest/slowhttptest.SlackBuild
@@ -0,0 +1,99 @@
+#!/bin/sh
+
+# Slackware build script for slowhttptest
+
+# Copyright 2014 P.D. Parnoff <cryptoanarquismo{strudel}biofcentral{period}com>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=slowhttptest
+VERSION=${VERSION:-1.6}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --sysconfdir=/etc \
+ --localstatedir=/var \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --build=$ARCH-slackware-linux
+
+make
+make install DESTDIR=$PKG
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a COPYING $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/network/slowhttptest/slowhttptest.info b/network/slowhttptest/slowhttptest.info
new file mode 100644
index 0000000000..579e9e59a2
--- /dev/null
+++ b/network/slowhttptest/slowhttptest.info
@@ -0,0 +1,10 @@
+PRGNAM="slowhttptest"
+VERSION="1.6"
+HOMEPAGE="https://code.google.com/p/slowhttptest/"
+DOWNLOAD="https://slowhttptest.googlecode.com/files/slowhttptest-1.6.tar.gz"
+MD5SUM="72ba999ffee6b00abe25e597fa1d83b2"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="P.D. Parnoff"
+EMAIL="cryptoanarquismo@biofcentral.com"